diff --git a/ChangeLog b/ChangeLog
index d994657dd9..6a80537c04 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -2,6 +2,8 @@
   * Fix error reading multi-layer XCF image file.
   * Fix possible stack overflow in WEBP reader (reference
     https://github.com/ImageMagick/ImageMagick/issues/907)
+  * Fixed numerous memory leaks (reference
+    https://github.com/ImageMagick/ImageMagick/issues).
 
 2017-12-16  6.9.9-27 Cristy  <quetzlzacatenango@image...>
   * Release ImageMagick version 6.9.9-26, GIT revision 12369:82d92312a:20171216.
diff --git a/coders/png.c b/coders/png.c
index d62c855a7f..dfae89d27a 100644
--- a/coders/png.c
+++ b/coders/png.c
@@ -2259,9 +2259,11 @@ static Image *ReadOnePNGImage(MngInfo *mng_info,
           "  exit ReadOnePNGImage() with error.");
 
       if (image != (Image *) NULL)
-        InheritException(exception,&image->exception);
-
-      return(GetFirstImageInList(image));
+        {
+          InheritException(exception,&image->exception);
+          image=DestroyImage(image);
+        }
+      return(image);
     }
 
   /* {  For navigation to end of SETJMP-protected block.  Within this
